﻿Imports System.IO
Imports System.IO.Ports
Imports System.Threading
Public Class VB_Remote
    Dim receivedData As String = ""
    Dim Decoded As String = ""
    Dim comPort As String
    Dim setBox As String
    Dim BUZZ As String
    Dim LED_RED As String
    Dim LED_GREEN As String
    Dim LED_BLUE As String
    Dim Flag_Buzz As Boolean = False
    Dim Flag_LED_R As Boolean = False
    Dim Flag_LED_G As Boolean = False
    Dim Flag_LED_B As Boolean = False
    Private Sub VB_Remote_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Timer1.Enabled = False
        comPort = ""
        For Each sp As String In My.Computer.Ports.SerialPortNames
            ComboBox1.Items.Add(sp)
        Next
        setBox = ""
        ComboBox2.Items.Add("BUZZ")
        ComboBox2.Items.Add("LED RED")
        ComboBox2.Items.Add("LED GREEN")
        ComboBox2.Items.Add("LED BLUE")
    End Sub
    Private Sub ComboBox1_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ComboBox1.SelectedIndexChanged
        If (ComboBox1.SelectedItem <> "") Then
            comPort = ComboBox1.SelectedItem
        End If
    End Sub
    Private Sub ComboBox2_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ComboBox2.SelectedIndexChanged
        If (ComboBox2.SelectedItem <> "") Then
            setBox = ComboBox2.SelectedItem
        End If
    End Sub
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        SerialPort1.Write("0")
        If (Flag_Buzz = False) Then
            Flag_Buzz = True
            Button1.BackColor = Color.DarkGray
        ElseIf (Flag_Buzz = True) Then
            Flag_Buzz = False
            Button1.BackColor = Color.Transparent
        End If
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        SerialPort1.Write("1")
        If (Flag_LED_R = False) Then
            Flag_LED_R = True
            Button2.BackColor = Color.IndianRed
        ElseIf (Flag_LED_R = True) Then
            Flag_LED_R = False
            Button2.BackColor = Color.Transparent
        End If
    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click
        SerialPort1.Write("2")
        If (Flag_LED_G = False) Then
            Flag_LED_G = True
            Button3.BackColor = Color.LimeGreen
        ElseIf (Flag_LED_G = True) Then
            Flag_LED_G = False
            Button3.BackColor = Color.Transparent
        End If
    End Sub

    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles Button4.Click
        SerialPort1.Write("3")
        If (Flag_LED_B = False) Then
            Flag_LED_B = True
            Button4.BackColor = Color.CornflowerBlue
        ElseIf (Flag_LED_B = True) Then
            Flag_LED_B = False
            Button4.BackColor = Color.Transparent
        End If
    End Sub
    Private Sub Button5_Click(sender As Object, e As EventArgs) Handles Button5.Click
        If (Button5.Text = "Connect") Then
            If (comPort <> "") Then
                SerialPort1.Close()
                SerialPort1.PortName = comPort
                SerialPort1.BaudRate = 9600
                SerialPort1.DataBits = 8
                SerialPort1.Parity = Parity.None
                SerialPort1.StopBits = StopBits.One
                SerialPort1.Handshake = Handshake.None
                SerialPort1.Encoding = System.Text.Encoding.Default
                SerialPort1.Open()
                Button5.Text = "Dis-con"
                Timer1.Enabled = True
                'Button_ComboBox.Enabled = True
            Else
                MsgBox("Select a COM port first")
            End If
        Else
            SerialPort1.Close()
            Button5.Text = "Connect"
            Timer1.Enabled = False
            'Button_ComboBox.Enabled = False
        End If
    End Sub
    Private Sub Button6_Click(sender As Object, e As EventArgs) Handles Button6.Click
        If (setBox = "BUZZ") Then
            BUZZ = Decoded
        ElseIf (setBox = "LED RED") Then
            LED_RED = Decoded
        ElseIf (setBox = "LED GREEN") Then
            LED_GREEN = Decoded
        ElseIf (setBox = "LED BLUE") Then
            LED_BLUE = Decoded
        End If
    End Sub
    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        receivedData = ReceiveSerialData()
        If ((receivedData.Contains("<") And receivedData.Contains(">"))) Then
            TextBox1.Clear()
            TextBox2.Clear()
            parseData()
        End If
        'RichTextBox1.AppendText(receivedData)
        'RichTextBox1.SelectionStart = RichTextBox1.TextLength
        'RichTextBox1.ScrollToCaret()
    End Sub
    'Read Serial fuction
    Function ReceiveSerialData() As String
        Dim Incoming As String
        Try
            Incoming = SerialPort1.ReadExisting()
            If Incoming Is Nothing Then
                Return "nothing" & vbCrLf
            Else
                Return Incoming
            End If
        Catch ex As Exception
            Return "Error: Serial Port read timed out"
        End Try
    End Function
    'Parsing Data
    Function parseData()
        ' uses the global variable receivedData
        Dim pos1 As Integer
        Dim pos2 As Integer
        Dim pos3 As Integer
        Dim Type As String
        Dim Hex As String
        Dim length As Integer
        Dim done As Boolean = False

        While (Not done)
            pos1 = receivedData.IndexOf("<") + 1
            pos2 = receivedData.IndexOf(">") + 1
            'occasionally we may not get complete data and the end marker will be in front of the start marker
            ' for exampe "55><"
            ' if pos2 < pos1 then remove the first part of the string from receivedData
            If (pos2 < pos1) Then
                receivedData = Microsoft.VisualBasic.Mid(receivedData, pos2 + 1)
                pos1 = receivedData.IndexOf("<") + 1
                pos2 = receivedData.IndexOf(">") + 1
            End If

            If (pos1 = 0 Or pos2 = 0) Then
                ' we do not have both start and end markers and we are done
                done = True
            Else
                ' we have both start and end markers
                length = pos2 - pos1 + 1
                If (length > 0) Then
                    'remove the start and end markers from the command
                    Decoded = Mid(receivedData, pos1 + 1, length - 2)
                    ' show the command in the text box
                    RichTextBox1.AppendText("Decoded = " & Decoded & vbCrLf)
                    'remove the command from receivedData
                    receivedData = Mid(receivedData, pos2 + 1)
                    If (Decoded.Contains(":")) Then
                        pos3 = Decoded.IndexOf(":") + 1
                        Type = Mid(Decoded, 1, pos3 - 1)
                        Hex = Mid(Decoded, pos3 + 2)
                        TextBox1.Text &= Type
                        TextBox2.Text &= "0x" + Hex
                    End If
                    If (Decoded = BUZZ) Then
                        SerialPort1.Write("0")
                        If (Flag_Buzz = False) Then
                            Flag_Buzz = True
                            Button1.BackColor = Color.DarkGray
                        ElseIf (Flag_Buzz = True) Then
                            Flag_Buzz = False
                            Button1.BackColor = Color.Transparent
                        End If
                    ElseIf (Decoded = LED_RED) Then
                        SerialPort1.Write("1")
                        If (Flag_LED_R = False) Then
                            Flag_LED_R = True
                            Button2.BackColor = Color.IndianRed
                        ElseIf (Flag_LED_R = True) Then
                            Flag_LED_R = False
                            Button2.BackColor = Color.Transparent
                        End If
                    ElseIf (Decoded = LED_GREEN) Then
                        SerialPort1.Write("2")
                        If (Flag_LED_G = False) Then
                            Flag_LED_G = True
                            Button3.BackColor = Color.LimeGreen
                        ElseIf (Flag_LED_G = True) Then
                            Flag_LED_G = False
                            Button3.BackColor = Color.Transparent
                        End If
                    ElseIf (Decoded = LED_BLUE) Then
                        SerialPort1.Write("3")
                        If (Flag_LED_B = False) Then
                            Flag_LED_B = True
                            Button4.BackColor = Color.CornflowerBlue
                        ElseIf (Flag_LED_B = True) Then
                            Flag_LED_B = False
                            Button4.BackColor = Color.Transparent
                        End If
                    End If
                End If ' (length > 0) 
            End If '(pos1 = 0 Or pos2 = 0)

        End While
    End Function

End Class
